// ga5answers.cpp
// by Glenn G. Chappell
// October 2003
//
// For CS 381
// Example program for vecpos.h
// Calculates and prints answers to Assignment #5 questions

#define TRANSF_OLD_STYLE_C_HEADERS
   // The above line tells vecpos.h to use <math.h> instead of <cmath>.
   // Some versions of MS-Vis C++ may need this.
#include "vecpos.h"
using tf::vec;  // If these lines annoy you, just do "using namespace tf;"
using tf::dot;
using tf::cross;

#include <iostream>
using std::cout;
using std::endl;
#include <iomanip>
using std::fixed;
using std::setprecision;
#include <math.h>  // Some versions of MS-Vis C++ have broken <cstdlib>
//using std::acos;


// operator<<
// For pretty-printing vec's.
// Prints in the format (#, #, #)
// with #'s replaced by the components of the vec.
std::ostream & operator<<(std::ostream & out, const vec & thevec)
{
   out << "("  << thevec[0]
       << ", " << thevec[1]
       << ", " << thevec[2]
       << ")";
   return out;
}


// ga5calc
// Calculates and prints the answers
//  to CS 381 Assignment #5 questions.
void ga5calc()
{
   const vec u(1, -1, 2);
   const vec v(0, 3, 1);

   cout << "CS 381" << endl;
   cout << "Assignment #5 Answers" << endl;
   cout << endl;
   cout << "u = " << u << "." << endl;
   cout << "v = " << v << "." << endl;
   cout << endl;

   vec answer1a = 2*u;
   cout << "1a. 2*u = " << answer1a << "." << endl;

   vec answer1b = u + v;
   cout << "1b. u + v = " << answer1b << "." << endl;

   vec answer1c = u - v;
   cout << "1c. u - v = " << answer1c << "." << endl;

   double answer1d = dot(u, v);  // or u.dot(v);
   cout << "1d. dot(u, v) = " << answer1d << "." << endl;

   vec answer1e = cross(u, v);  // or u.cross(v);
   cout << "1e. cross(u, v) = " << answer1e << "." << endl;

   const double pi = 3.1415926535897932384626433832795;
      // Yes, I know about M_PI.
      // Did you know that it is NOT part of the C++ standard?
      // How 'bout that ....
   double angle_in_radians = acos( dot(u,v)/(u.length() * v.length()) );
   double answer1f = angle_in_radians * (180./pi);  // Convert to degrees.
   cout << "1f. Angle between u & v: "
        << fixed << setprecision(1) << answer1f     // Answer to 1 decimal place
        << " degrees (approximately)." << endl;

   cout << endl;
}


int main()
{
   ga5calc();  // Calculate and print Assignment #5 answers

   return 0;
}